BLApp.factory('databaseFactory', ['$rootScope', '$location', 'CommonFactory', 
	function ($rootScope, $location, CommonFactory) {
		return{
			userDB : function (tx) {
				var dataToDB = JSON.parse(localStorage.getItem("data"));
				tx.executeSql('DROP TABLE IF EXISTS PERSON');
				tx.executeSql('CREATE TABLE IF NOT EXISTS PERSON (key, value)');
				$.each(dataToDB, function(key, value) {
					tx.executeSql('INSERT INTO PERSON (key, value) VALUES (?,?)', [key,value]);
				});
				localStorage.removeItem("data");
				//$location.path(localStorage.getItem("userPreferredScreen"));
				if (!$rootScope.$$phase) $rootScope.$apply();
			},
			
			/*progressDB : function (tx) {
				tx.executeSql('DROP TABLE IF EXISTS PROGRESSPLAN');
				tx.executeSql('CREATE TABLE IF NOT EXISTS PROGRESSPLAN (currentDate,expireDate,days,response)');
			},
			
			insertProgressDB : function (tx) {
				tx.executeSql('CREATE TABLE IF NOT EXISTS PROGRESSPLAN (currentDate,expireDate,days,response)');
				tx.executeSql('INSERT INTO PROGRESSPLAN (currentDate,expireDate,days,response) VALUES (?,?,?,?)', [$rootScope.currentDate1,$rootScope.expireDate,$rootScope.saveTill,$rootScope.progressPlan]);
			},
			UpdateProgressDB : function (tx) {
				//alert(2);
				tx.executeSql('CREATE TABLE IF NOT EXISTS PROGRESSPLAN (currentDate,expireDate,days,response)');
				tx.executeSql("UPDATE PROGRESSPLAN SET expireDate = '"+ $rootScope.expireDate +"', days = '"+ $rootScope.saveTill +"', response ='" +$rootScope.progressPlanPerDay+"' WHERE currentDate = '"+$rootScope.currentDate2+"' ;", [], this.errorCB, this.successCB);
			},
			deleteProgressDB : function (tx) {
				//alert(3);
				//tx.executeSql('DROP TABLE IF EXISTS PROGRESSPLAN');
				var currentDateForDelete = CommonFactory.getCurrentDate();
				tx.executeSql("DELETE FROM PROGRESSPLAN WHERE expireDate <= '"+ currentDateForDelete +"'");
			},*/
			
			getProBulkDetails : function (tx, results){  /* bulk database */
				$rootScope.progressPlanOffline = results.rows.item(0);
				$rootScope.resultFromDb = true;
				loadProgressAfterAPI($rootScope.progressPlanOffline.ProgressResponse,200);
			},
			
			getAddExercise : function (tx, results){
				if(results.rows.length > 0){
					$rootScope.resultFromDb = true;
					$rootScope.exerciseResponce = results.rows.item(0).responce;
					searchResultsExercise($rootScope.exerciseResponce);	
					if (!$rootScope.$$phase) $rootScope.$apply();
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},
			
			getFitnesstypeSelectDB : function (tx, results){
				$rootScope.fitnessTypeOffline = results.rows.item(0);
				$rootScope.resultFromDb = true;
				loadCategoriesForSaveFitnessPlansTAfterAPI($rootScope.fitnessTypeOffline.fptresponse,200);
			},

			getDietPlanDetail : function (tx, results){  
				if(results.rows.length > 0){
					$rootScope.resultFromDb = true;
					var data = JSON.parse(results.rows.item(0).dietplanresponse);
					loadDietPlanDayAfterAPI(data,"200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getFollowRecDetail : function (tx, results){
				if(results.rows.length > 0){
					var data = JSON.parse(results.rows.item(0).followdietrecom);
					$rootScope.resultFromDb = true;
					loadRecomDietPlanDayAfterAPI(data, "200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getFollowAllDetail : function (tx, results){
				if(results.rows.length > 0){
					var data = JSON.parse(results.rows.item(0).followdietall);
					$rootScope.resultFromDb = true;
					loadAllDietPlanDayAfterAPI(data, "200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getSearchDetail : function (tx, results){
				if(results.rows.length > 0){
					$rootScope.resultFromDb = true;
					searchResults(results.rows.item(0).searchresponse);
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getFavFoodItem : function (tx, results){
				if(results.rows.length > 0){
					$rootScope.resultFromDb = true;
					var data = JSON.parse(results.rows.item(0).recentfavresponse);
					loadFavoriteFoodItemAfterAPI(data, "200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getRecentFoodItem : function (tx, results){
				if(results.rows.length > 0){
					$rootScope.resultFromDb = true;
					var data = JSON.parse(results.rows.item(0).recentfavresponse);
					loadRecentMealAfterAPI(data, "200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getRecipesDB : function (tx, results){
				if(results.rows.length > 0){
					var data = JSON.parse(results.rows.item(0).rescresponse);
					$rootScope.resultFromDb = true;
					loadRecipesAfterAPI(data, "200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getAllFitPlan : function (tx, results){
				if(results.rows.length > 0){
					$rootScope.FitPlanFollowAll = results.rows.item(0).fpffAll;
					$rootScope.resultFromDb = true;
					fitnessPlansAllAfterAPI($rootScope.FitPlanFollowAll, "200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getRecFitPlan : function (tx, results){
				if(results.rows.length > 0){
					$rootScope.FitPlanFollowReco = results.rows.item(0).fpffReco;
					$rootScope.resultFromDb = true;
					fitnessPlansRecomAfterAPI($rootScope.FitPlanFollowReco, "200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getSavedFitPlan : function (tx, results){
				if(results.rows.length > 0){
					$rootScope.FitPlanFollowSave = results.rows.item(0).fpffSaved;
					$rootScope.resultFromDb = true;
					fitnessPlansSavedAfterAPI($rootScope.FitPlanFollowSave, "200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			}, 

			getAllExerciseDetail : function (tx, results){
				if(results.rows.length > 0){
					var data = JSON.parse(results.rows.item(0).fitplanresponse);
					loadWorkOutDayAfterAPI(data, "200");
				}else{
					$rootScope.showLoadingScreen = false;
     				if (!$rootScope.$$phase) $rootScope.$apply();
				}
			},

			getFatChartDetails : function (tx, results){
				$rootScope.fatChartOffline = results.rows.item(0);
				$rootScope.resultFromDb = true;
				var BodychartOption = $('#Bodychart :selected').val();
				if(BodychartOption == 'LEAN_MASS'){
					bodyFatChartAfterAPI($rootScope.fatChartOffline.LEAN_MASS,200);
				}
				else if(BodychartOption == 'FAT_MASS'){
					bodyFatChartAfterAPI($rootScope.fatChartOffline.FAT_MASS,200);
				}
				else{
					bodyFatChartAfterAPI($rootScope.fatChartOffline.BODY_FAT_PERCENTAGE,200);
				}
				//bodyFatChartAfterAPI($rootScope.fatChartOffline.LEAN_MASS,200);
			},
			getMeasureChartDetails : function (tx, results){
				$rootScope.measureChartOffline = results.rows.item(0);
				$rootScope.resultFromDb = true;
				var measurechartOption = $('#measureChart :selected').val();
				if(measurechartOption == 'NECK'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.NECK,200);
				}
				else if(measurechartOption == 'RIGHT_BICEP'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.RIGHT_BICEP,200);
				}
				else if(measurechartOption == 'RIGHT_FOREARM'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.RIGHT_FOREARM,200);
				}
				else if(measurechartOption == 'HIPS'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.HIPS,200);
				}
				else if(measurechartOption == 'RIGHT_THIGH'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.RIGHT_THIGH,200);
				}
				else if(measurechartOption == 'RIGHT_CALF'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.RIGHT_CALF,200);
				}
				else if(measurechartOption == 'CHEST'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.CHEST,200);
				}
				else if(measurechartOption == 'LEFT_BICEP'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.LEFT_BICEP,200);
				}
				else if(measurechartOption == 'LEFT_FOREARM'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.LEFT_FOREARM,200);
				}
				else if(measurechartOption == 'WAIST'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.WAIST,200);
				}
				else if(measurechartOption == 'LEFT_THIGH'){
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.LEFT_THIGH,200);
				}
				else{
					setMeasureChartSelectAfterAPI($rootScope.measureChartOffline.LEFT_CALF,200);
				}
			},
			getProgWeightBulkDetails : function (tx, results){
				$rootScope.progressWightOffline = results.rows.item(0);
				$rootScope.resultFromDb = true;
				showWeightChartAfterAPI($rootScope.progressWightOffline.weightResponse,200);
			},
			getMeasureDbDetails : function (tx, results){
				$rootScope.progressMeasurOffline = results.rows.item(0);
				$rootScope.resultFromDb = true;
				startLatestMeasurmentsAPI($rootScope.progressMeasurOffline.measureResponse,200);
			},
			getCatogeForSaveDbDetails : function (tx, results){
				$rootScope.CatogSaveFitOffline = results.rows.item(0);
				$rootScope.resultFromDb = true;
				loadCategoriesForSaveFitnessPlansAfterAPI($rootScope.CatogSaveFitOffline.fpetypesresponse,200);
			},
			geProPicDbDetails : function (tx, results){
				$rootScope.progressProPicOffline = results.rows.item(0);
				$rootScope.resultFromDb = true;
				progressImgAPI($rootScope.progressProPicOffline.progPicResponse,200);
			},
			newUserDB : function (tx) {
				var dataToDB = JSON.parse(localStorage.getItem("data"));
				tx.executeSql('DROP TABLE IF EXISTS PERSON');
				tx.executeSql('CREATE TABLE IF NOT EXISTS PERSON (key, value)');
				$.each(dataToDB, function(key, value) {
					tx.executeSql('INSERT INTO PERSON (key, value) VALUES (?,?)', [key,value]);
				});
				localStorage.removeItem("data");
				$location.path("/selectPlans");
				if (!$rootScope.$$phase) $rootScope.$apply();
			},
			
			setUserDetails : function (tx, results){
				var len = results.rows.length;
				for (var i=0; i<len; i++){
					//alert("Row = " + i + " key = " + results.rows.item(i).key + " value =  " + results.rows.item(i).value);
					if (results.rows.item(i).key == "username")
						localStorage.setItem("username" , results.rows.item(i).value);
					if (results.rows.item(i).key == "uuid")
						localStorage.setItem("uuid" , results.rows.item(i).value);
				}
				//$location.path(localStorage.getItem("userPreferredScreen"));
				if (!$rootScope.$$phase) $rootScope.$apply();
			},
			
			fitnessPlanDB : function (tx) {
				var dataToDB = localStorage.getItem("selectedFitnessPlan");
				//tx.executeSql('DROP TABLE IF EXISTS PERSON');
				tx.executeSql('CREATE TABLE IF NOT EXISTS FITNESS (key, value)');
				tx.executeSql('INSERT INTO FITNESS (key, value) VALUES (?,?)', ["plan" , dataToDB]);
			},
			
			mealPlanDB : function (tx) {
				var dataToDB = localStorage.getItem("selectedMealPlan");
				//tx.executeSql('DROP TABLE IF EXISTS PERSON');
				tx.executeSql('CREATE TABLE IF NOT EXISTS MEAL (key, value)');
				tx.executeSql('INSERT INTO MEAL (key, value) VALUES (?,?)', ["plan" , dataToDB]);
			},
			errorCB : function (err) {
				//alert("Error processing SQL: " + err.message);
				console.log("Error processing SQL: " + err.message);
			},

			successCB : function () {
				//alert("DB success!");
				console.log("DB success!");
			}
		}
	}
]);